﻿	' Uses only integers in per-sample logic!
	Public Class AttackDecayEnvelope
    Implements IMonoSampleProvider

    Private Const BITS16 As Long = 1 << 16

    Private Const BITS24 As Long = 1 << 24

    Private Const BITS32 As Long = 1L << 32


    Private sampleRate As Integer

    Private volume_Renamed As Long = BITS16 ' ranges from 0x10000 to 0x100000000

    Private direction As Integer ' 1 for attack, -1 for decay, 0 for hold

    Private upMultiplier As Long

    Private downMultiplier As Long

		Public Sub New(ByVal sampleRate As Integer)
			Me.sampleRate = sampleRate
			Me.AttackTime = TimeSpan.FromMilliseconds(100)
			Me.DecayTime = TimeSpan.FromSeconds(1)
		End Sub

		Public Property Input As IMonoSampleProvider

		Public Property AttackTime As TimeSpan

		Public Property DecayTime As TimeSpan

		Public ReadOnly Property Volume As Double
			Get
				Return volume_Renamed / CDbl(BITS32)
			End Get
		End Property

		Public Sub Attack()
        upMultiplier = CLng(BITS24 * Math.Pow(2, 16 / (sampleRate * Me.AttackTime.TotalSeconds)))
        downMultiplier = CLng(BITS24 / Math.Pow(2, 16 / (sampleRate * Me.DecayTime.TotalSeconds)))
        direction = 1
    End Sub

    Public Function GetNextSample() As Short Implements IMonoSampleProvider.GetNextSample
        Dim sample As Short = 0

        If Me.Input IsNot Nothing Then
            sample = Me.Input.GetNextSample()
        End If

        Select Case direction
            Case 1 ' attack
                volume_Renamed *= upMultiplier
                volume_Renamed >>= 24

                If volume_Renamed >= BITS32 Then
                    volume_Renamed = BITS32
                    direction = -1
                End If

            Case -1 ' decay
                volume_Renamed *= downMultiplier
                volume_Renamed >>= 24

                If volume_Renamed <= BITS16 Then
                    volume_Renamed = BITS16
                    direction = 0
                End If

            Case 0
                Return 0
        End Select
        Return CShort((volume_Renamed * sample) >> 32)
    End Function
	End Class
