﻿' Uses only integers in per-sample logic!
Public Class IntegerMixerInput
    Implements IMixerInput

    Private iVolume As Integer

    Private iSpace As Integer

    Public Sub New()
        Me.Volume = 1
    End Sub

    Public Sub New(ByVal input As IMonoSampleProvider)
        Me.New()
        Me.Input = input
    End Sub

    Public Property Input As IMonoSampleProvider

    ' Ranges from 0 to 1
    Public Property Volume As Double
        Set(ByVal value As Double)
            iVolume = CInt(65536.0 * Math.Min(1, Math.Max(0, value)))
        End Set

        Get
            Return iVolume / 65536.0
        End Get
    End Property

    ' Ranges from -1 (left) to 0 (center) to 1 (right)
    Public Property Space As Double
        Set(ByVal value As Double)
            iSpace = CInt(65536.0 * Math.Min(1, Math.Max(-1, value)))
        End Set

        Get
            Return iSpace / 65536.0
        End Get
    End Property

    Public Function GetNextSample() As AudioSample Implements Petzold.MusicSynthesis.IStereoSampleProvider.GetNextSample
        Dim sample As Short = 0

        If iVolume = 0 Then
            Return New AudioSample
        End If

        If Me.Input IsNot Nothing Then
            sample = Input.GetNextSample()
        End If

        If sample = 0 Then
            Return New AudioSample
        End If

        Return New AudioSample With {.Left = CShort((CLng(sample)) * iVolume * (65536 - iSpace)) >> 33, .Right = CShort((CLng(sample)) * iVolume * (65536 + iSpace)) >> 33}
    End Function
End Class
