﻿Public Class Mixer
    Implements IStereoSampleProvider

    Public Sub New()
        Me.Inputs = New List(Of IMixerInput)
        Me.Volume = 1
    End Sub

    Private privateInputs As IList(Of IMixerInput)
    Public Property Inputs As IList(Of IMixerInput)
        Get
            Return privateInputs
        End Get

        Protected Set(ByVal value As IList(Of IMixerInput))
            privateInputs = value
        End Set
    End Property

    Public Property Volume As Double

    Public Function GetNextSample() As AudioSample Implements IStereoSampleProvider.GetNextSample
        Dim left As Integer = 0
        Dim right As Integer = 0

        For Each mixerInput As IMixerInput In Me.Inputs
            Dim audioSample As AudioSample = mixerInput.GetNextSample()
            left += audioSample.Left
            right += audioSample.Right
        Next mixerInput

        ' Quicken the calculation
        If Me.Volume = 1 Then
            Return New AudioSample With {.Left = CShort(left \ Me.Inputs.Count), .Right = CShort(right \ Me.Inputs.Count)}
        End If

        Return New AudioSample With {.Left = CShort(Me.Volume * left \ Me.Inputs.Count), .Right = CShort(Me.Volume * right \ Me.Inputs.Count)}
    End Function
End Class
