﻿Public Class MixerInput
    Implements IMixerInput

    Private _volume As Double

    Private _space As Double

    Public Sub New()
        Me.Volume = 1
    End Sub

    Public Sub New(ByVal input As IMonoSampleProvider)
        Me.New()
        Me.Input = input
    End Sub

    Public Property Input As IMonoSampleProvider

    ' Ranges from 0 to 1
    Public Property Volume As Double
        Set(ByVal value As Double)
            _volume = Math.Min(1, Math.Max(0, value))
        End Set

        Get
            Return _volume
        End Get
    End Property

    ' Ranges from -1 (left) to 0 (center) to 1 (right)
    Public Property Space As Double
        Set(ByVal value As Double)
            _space = Math.Min(1, Math.Max(-1, value))
        End Set

        Get
            Return _space
        End Get
    End Property

    Public Function GetNextSample() As AudioSample Implements Petzold.MusicSynthesis.IStereoSampleProvider.GetNextSample
        Dim sample As Short = 0

        If Me.Input IsNot Nothing Then
            sample = Input.GetNextSample
        End If

        Return New AudioSample With {.Left = CShort(sample * Me.Volume * (1 - Me.Space) / 2), .Right = CShort(sample * Me.Volume * (1 + Me.Space) / 2)}
    End Function
End Class
