﻿Public MustInherit Class Oscillator
    Implements IMonoSampleProvider

    Private sampleRate As Integer

    Private angleIncrement As Double

    Private angle As Double

    Private Sub New()
    End Sub

    Public Sub New(ByVal sampleRate As Integer)
        Me.New()
        Me.sampleRate = sampleRate
    End Sub

    Public Property Frequency As Double
        Set(ByVal value As Double)
            angleIncrement = 2 * Math.PI * value / sampleRate
        End Set

        Get
            Return angleIncrement * sampleRate \ 2 / Math.PI
        End Get
    End Property

    Public Function GetNextSample() As Short Implements IMonoSampleProvider.GetNextSample
        Dim sample As Short = GetNextSample(angle)
        angle = (angle + angleIncrement) Mod (2 * Math.PI)
        Return sample
    End Function

    ' angle argument ranges from 0 to 2*PI
    Public MustOverride Function GetNextSample(ByVal angle As Double) As Short
End Class
