﻿Imports Petzold.MusicSynthesis

Public Class ThereminOscillator
    Inherits Oscillator

    Private ReadOnly ampStep As Double

    Private ReadOnly freqStep As Double

    Public Const MIN_AMPLITUDE As Double = 0.0001

    Public Sub New(ByVal sampleRate As Integer)
        MyBase.New(sampleRate)
        ampStep = 1 + 0.12 * 1000 \ sampleRate ' ~1 db per msec
        freqStep = 1 + 0.005 * 1000 \ sampleRate ' ~10 cents per msec
    End Sub

    Public Property Amplitude As Double

    Public Property DestinationAmplitude As Double

    Public Property DestinationFrequency As Double

    Public Overrides Function GetNextSample(ByVal angle As Double) As Short
        Me.Frequency *= If(Me.Frequency < Me.DestinationFrequency, freqStep, 1 / freqStep)
        Me.Amplitude *= If(Me.Amplitude < Me.DestinationAmplitude, ampStep, 1 / ampStep)
        Me.Amplitude = Math.Max(MIN_AMPLITUDE, Math.Min(1, Me.Amplitude))
        Return CShort(Short.MaxValue * Me.Amplitude * Math.Sin(angle))
    End Function
End Class
